import csv #traitement csv
from bs4 import BeautifulSoup
import time

seuil=33
couleurcirc={}
FicSource=csv.reader(open('../Donnees/SourcesQuanti/abstention30pc.tsv','r',encoding='UTF-8'), delimiter='\t')

lignes=list(FicSource)
enTete = lignes.pop(0)

for lignecourante in lignes:
	ident=lignecourante[0]
	valeur=	float(lignecourante[3])

	if valeur > seuil:
		couleurcirc[ident]="red"
	else:
		couleurcirc[ident]="yellow"

with open("../Donnees/Cartes/Fond.html", "r",encoding='utf8') as FicFondorigine:
	DonneesHtml = FicFondorigine.read()  
	puree = BeautifulSoup(DonneesHtml, features="html.parser")	

zoomParis=puree.find("g",{"id":"RPzoomcirc"})
zoomParis=zoomParis.find_all("path")
for circ in zoomParis:
	idcirc=circ["id"].split("-")[1]
	circ["fill"]=couleurcirc[idcirc]

Autres=puree.find("g",{"id":"Circ"})
Autres=Autres.find_all("path")
for circ in Autres:
	idcirc=circ["id"].split("-")[0]
	circ["fill"]=couleurcirc[idcirc]
			
with open("../Donnees/Cartes/cartesimple.html", "wb") as f:
	f.write(puree.prettify("utf-8")) #"utf-8"
